#pragma once
// zoomasm -- zoom video assembler
// (c) 2019,2020 Claude Heiland-Allen
// SPDX-License-Identifier: AGPL-3.0-or-later

#include <filesystem>

struct colour;

extern struct colour *colour_new(const char *version);
extern void colour_delete(struct colour *clr);

extern bool colour_get_compiled(const struct colour *clr);

extern void colour_display_early(struct colour *clr);
extern bool colour_display_late(struct colour *clr);
extern void colour_compile_shader(struct colour *clr, bool reload);

extern void colour_draw(struct colour *clr, double phase_start, double phase_end, double time_start, double time_end, bool flip, double invert, double aspect_x, double aspect_y, int keyframe_count);
extern void colour_blit(struct colour *clr);

extern std::filesystem::path colour_get_colour(const struct colour *clr);
extern bool colour_set_colour(struct colour *clr, const std::filesystem::path &file);

extern bool colour_get_watch(const struct colour *clr);
extern bool colour_set_watch(struct colour *clr, bool watch);

extern int colour_get_samples(const struct colour *clr);
extern bool colour_set_samples(struct colour *clr, int samples);

extern double colour_get_shutter(const struct colour *clr);
extern bool colour_set_shutter(struct colour *clr, double shutter);
